function [Str_out] = char(X)
%CHAR  Convert a polynomial object to a cell matrix with chars
%
Xs=X.s;
Xv=X.v;
Xd=X.d;
if isempty(Xd) | any(isinf(Xd)),  % J.Jezek
   Xc = zeros(Xs(1),Xs(2),0,0);   %
   Xd = [1 1];                    %
end;                              %
Xc=X.c;
Str_out=cell(Xs(1),Xs(2)); % output matrix

Str_Mtr=cell(Xd(1)+1,Xd(2)+1); % Cell-matrix of generated string terms
Str_Vctr=cell(1,(Xd(1)+1)*(Xd(2)+1));

% String-terms for further string compilation
%---------------------
for d1i=0:Xd(1),
    for d2i=0:Xd(2),
        if d1i==0, % check for variable x
            x_str='';
        elseif d1i==1,
            x_str='x';
        else,
            x_str=strcat('x^',num2str(d1i));
        end; %  if d1i==0, % check for variable x
        
        if d2i==0, % check for variable y
            y_str='';
        elseif d2i==1,
            y_str='y';
        else,
            y_str=strcat('y^',num2str(d2i));
        end; % if d2i==0, % check for variable y
        
        % the string compilation for one coefficient
        if isempty(x_str) & isempty(y_str), % to bypass the exception
            Str_Mtr{d1i+1,d2i+1}='';
        elseif xor(isempty(x_str),isempty(y_str)),
            Str_Mtr{d1i+1,d2i+1}=strcat(x_str,y_str);
        else,
            Str_Mtr{d1i+1,d2i+1}=strcat(x_str,'*',y_str);
        end; % if isempty(x_str) & isempty(x_str),
            
    end;
end;  %for d1i=0:Xd(1),
%---------------------
% Vector of string-terms ; diagonal by diagonal - X first
Pos_In_Vctr=1;
if Xd(1)==0, % extract diagonals from a horizontal vector - just y-polynomial
    Str_Vctr=Str_Mtr;
elseif Xd(2)==0, % extract diagonals from a vertical vector - just x-polynomial
    Str_Vctr=Str_Mtr';
elseif Xd(1)~=0 & Xd(2)~=0, % extract diagonals from a matrix
    Str_Mtr=flipud(Str_Mtr); % x-first
    for diag_indx=-Xd(1):Xd(2),
        diag_tmp=diag(Str_Mtr,diag_indx)';
        Length_diag=length(diag_tmp);
        Str_Vctr(Pos_In_Vctr:Pos_In_Vctr+Length_diag-1)=diag_tmp;
        Pos_In_Vctr=Pos_In_Vctr+Length_diag;
    end; %for
end; % if
%---------------------
clear Str_Mtr Pos_In_Vctr Length_diag diag_tmp
%------------------- The String-Term-Vector is now created ----
%--------------------------------------------------------------

Coe_Mtr=zeros(Xd(1)+1,Xd(2)+1);  % matrix of coefficients
N_chars=0;
% Sort coefficients by sum of variable power 
for ri=1:Xs(1),
    for ci=1:Xs(2),
        Coe_Mtr=squeeze(Xc(ri,ci,:,:)); %2-D matrix for work with
        if Xd(1)==0, % exception - too many dimesions have been squeezed
%           Coe_Mtr=Coe_Mtr';   J.Jezek  27-Apr-2003
            Coe_Mtr=Coe_Mtr.';
        end; 
        Pos_In_Vctr=1;
        % Vector asembling---------
        Coe_Vctr=zeros(1,(Xd(1)+1)*(Xd(2)+1));
        if Xd(1)==0, % extract diagonals from a horizontal vector 
            Coe_Vctr=Coe_Mtr;
        elseif Xd(2)==0, % extract diagonals from a vertical vector
%           Coe_Vctr=Coe_Mtr';      J.Jezek  27-Apr-2003
            Coe_Vctr=Coe_Mtr.';           
        elseif Xd(1)~=0 & Xd(2)~=0,
            Coe_Mtr=flipud(Coe_Mtr);
            for diag_indx=-Xd(1):Xd(2),
%               diag_tmp=diag(Coe_Mtr,diag_indx)';   J.Jezek 27-Apr-2003
                diag_tmp=diag(Coe_Mtr,diag_indx).';
                Length_diag=length(diag_tmp);
                Coe_Vctr(Pos_In_Vctr:Pos_In_Vctr+Length_diag-1)=diag_tmp;
                Pos_In_Vctr=Pos_In_Vctr+Length_diag;
            end; %for
        end; %if 
        %--------------------------
        % Finishing ----- Coeff & strings
        length_Vctr=length(Coe_Vctr);
        Str_out{ri,ci}=[];
        Str_out_aux=[];
        for Pos_indx=1:length_Vctr,
            if isreal(Coe_Vctr(Pos_indx)),
                if Coe_Vctr(Pos_indx)==-1 & ~isempty(Str_Vctr{Pos_indx}),
                    Str_out_aux=[Str_out_aux,' - ',Str_Vctr{Pos_indx}];
                elseif Coe_Vctr(Pos_indx)<0,
                    Str_out_aux=[Str_out_aux,' - ',num2str(abs(Coe_Vctr(Pos_indx))),Str_Vctr{Pos_indx}];
                elseif Coe_Vctr(Pos_indx)==1 & ~isempty(Str_Vctr{Pos_indx}),
                    Str_out_aux=[Str_out_aux,' + ',Str_Vctr{Pos_indx}];
                elseif Coe_Vctr(Pos_indx)>0,
                    Str_out_aux=[Str_out_aux,' + ',num2str(Coe_Vctr(Pos_indx)),Str_Vctr{Pos_indx}];
                end;
            else % complex coefficients
                Str_out_aux=[Str_out_aux,' + (',num2str(Coe_Vctr(Pos_indx)),')',Str_Vctr{Pos_indx}];
                
            end %if isreal(Coe_Vctr(Pos_indx))
        end;
        %----------------
       
        if isempty(Str_out_aux),
            Str_out_aux=' 0';
        elseif Str_out_aux(2)=='+', % handle the exception ' + 10x ...' -> ' 10x ...'
            Str_out_aux(1:2)='';
        end;
        Str_out{ri,ci}=Str_out_aux;
    end; % for ci=1:Xs(2),
end;   % for ri=1:Xs(1),

%clear Str_out
%


% function s_f = fn2str(nn)
% fr_b=get(0,'Format');
% s_f='';
% switch fr_b,
% case 'short',
%    if (nn==round(nn)& abs(nn)<1e10),
%       s_f=num2str(nn,'%11.0f');
%    elseif (nn~=round(nn)& (abs(nn)<1000) & (abs(nn)>0.001)),
%       s_f=num2str(nn,'%11.4f');
%    else,
%       s_f=num2str(nn,'%11.4e');
%    end;
% case {'shortE','hex'},
%    if (nn==round(nn)& abs(nn)<1e10),
%       s_f=num2str(nn,'%11.0f');
%    else,
%       s_f=num2str(nn,'%11.4e');
%    end;
% case 'shortG',
%    s_f=num2str(nn,'%11.5g');
% case 'long',
%    if (nn==round(nn)& abs(nn)<1e10),
%       s_f=num2str(nn,'%21.0f');
%    elseif (nn~=round(nn)& (abs(nn)<100) & (abs(nn)>0.001)),
%        s_f=num2str(nn,'%21.15f');
%    else,
%       s_f=num2str(nn,'%21.15e');
%    end;  
% case 'longE',
%    if (nn==round(nn)& abs(nn)<1e15),
%       s_f=num2str(nn,'%21.0f');
%    else,
%       s_f=num2str(nn,'%21.15e');
%    end;
% case 'longG',
%    s_f=num2str(nn,'%21.15g');
% case 'bank',
%    s_f=num2str(nn,'%11.2f');
% case 'rational',
%    [n1,d1]=rat(nn);
%    sd1='';
%    sn1 = num2str(n1);
%    if abs(d1)~=1, 
%       sd1 = ['/',int2str(d1)];
%       if ~isreal(n1), sn1=['(',sn1,')']; end;
%    end;
%    s_f=[sn1,sd1];
% case '+',
%    if nn>0, s_f='+';
%    elseif nn<0, s_f='-';
%    end;
% end

