function Act = ctranspose(A);
%CTRANSPOSE   Conjugate transpose of 2-D polynomial
%                 A'
% The commands
%       AT = A'
%       AT = CTRANSPOE(A)
% return the conjugate transpose of 2-D polynomial:
%   AT(x,y) = CONJ(TRANSPOSE(AT(-x,-y)))

Act.d = A.d;
Act.s = fliplr(A.s);
Act.c = conj(permute(A.c,[2,1,3,4]));
Act.v = A.v;
Act.u = [];
Act = class(Act,'pol2');

Ad = A.d;
if isempty(Ad), return;
end;

An1 = Ad(1)+1; An2 = Ad(2)+1;
if isinf(An1), An1 = 0;
end;
if isinf(An2), An2 = 0;
end;

An1h = ceil(An1/2); An2h = ceil(An2/2);
g = ones(1,1,2,2);
g(1,1,2,1) = -1; g(1,1,1,2) = -1;
gg = repmat(g,[Act.s(1),Act.s(2),An1h,An2h]);
gg = gg(:,:,1:An1,1:An2);

Act.c = Act.c .* gg;

%end .. @pol2/ctranspose



