function display(PP)

%DISPLAY   Display 2-D polynomial matrix
%
Ps=PP.s;
Pv=PP.v;
Pd=PP.d;
% headline display
iname = [inputname(1),' = '];
if isempty(Pd) | Pd==[0,0],      % J.Jezek
   disp(' ');
   disp(['2-D constant polynomial matrix: ', int2str(Ps(1)),'-by-',int2str(Ps(2))]);
   
else
   disp(' ');
   disp(['2-D polynomial matrix: ', int2str(Ps(1)),'-by-',int2str(Ps(2))]);
   disp(['deg(',Pv(1),')=',int2str(Pd(1)),', deg(',Pv(2),')=',int2str(Pd(2))]);
end;
disp(' ');
disp([iname]);
disp(' ');
% c=char(32*ones(2,1));

Str_cell=char(PP);
if isempty(Str_cell),                                                    % J.Jezek
   if Ps(1)==0 & Ps(2)==0,                                               %
      disp('   []');                                                     %
   else                                                                  %
      disp(['   Empty matrix: ',int2str(Ps(1)),'-by-',int2str(Ps(2))]);  %
   end;                                                                  %
   return;                                                               %
end;                                                                     %
% Print format  - max 80 chars per row
Char_width=0;
Char_out=[];
Vata=char(32*zeros(Ps(1),5));
last_nonprinted_col=1;
Char_width=0;

for Col_indx=1:size(Str_cell,2),
    Char_width_inc=size(char(Str_cell{:,Col_indx}),2);
    % fill part
    if isempty(Char_out), % Just one-/first-column case
        Char_out=[char(Str_cell{:,Col_indx})];  
        Char_width=Char_width_inc;
    elseif Char_width+Char_width_inc > 80, %print the old a put-in the new
        if last_nonprinted_col==Col_indx-1,
            disp(['  Column ',int2str(Col_indx)-1]);
        else
            disp(['  Columns ',int2str(last_nonprinted_col),' through ',int2str(Col_indx)-1]);
        end;
        disp(' '); 
        disp(Char_out);
        disp(' ');
        %put-in the new
        last_nonprinted_col=Col_indx;
        Char_out=[char(Str_cell{:,Col_indx})];
        Char_width=Char_width_inc;
    elseif Char_width+Char_width_inc <= 80,  % just add a new column
        Char_out=[Char_out,Vata,char(Str_cell{:,Col_indx})];
        Char_width=Char_width+Char_width_inc;    
    end;
    
    % extra print part - printing by last column
    if size(Str_cell,2)==1,
        disp(' ');
        disp(Char_out);
        disp(' ');
    elseif (size(Str_cell,2)~=1) & (Col_indx==size(Str_cell,2)) & ~isempty(Char_out), % last print
        if last_nonprinted_col==1,  % => only one printing 
            disp(' '); 
            disp(Char_out);
            disp(' ');
        else
            if last_nonprinted_col==Col_indx,
                disp(['  Column ',int2str(Col_indx)]);
            else
                disp(['  Columns ',int2str(last_nonprinted_col),' through ',int2str(Col_indx)]);
            end;
            disp(' '); 
            disp(Char_out);
            disp(' ');
        end
        
    end; %if size(Str_cell,2)==1,
    %------------------------------
end; %for Col_indx=1:size(Str_cell,2),

%disp([char(Str_cell{:,1}),Vata,char(Str_cell{:,2})]);
 
