function b = integral(a,var)
%INTEGRAL    Integral of 2-D polynomial
%
% The command  B = INTEGRAL(A,VAR)  returns the integral
% of 2-D polynomial A according to variable VAR. The
% second argument must be 'x' or 'y'.  If omitted or
% given [x y] then both integrations are performed,
% the result reeides in a cell vector.

ni = nargin; err = 0;
if ni==2,
   if isa(var,'char'),
      if strcmp(var,'x') | strcmp(var,'y') | ...
         strcmp(var,'xy') | all(var==['x';'y']),
      else err = 1;
      end;
   elseif isa(var,'pol2'),
      [vs1,vs2,vd1,vd2] = size(var.c);
      if all([vs1,vs2,vd1,vd2]==[1 1 2 1]) & ...
            all(var.c(:)==[0;1]),
         var = 'x';
      elseif all([vs1,vs2,vd1,vd2]==[1 1 1 2]) & ...
            all(var.c(:)==[0;1]),
         var = 'y';
      elseif all([vs1,vs2,vd1,vd2]==[1 2 2 2]) & ...
            all(var.c(:)==[0;0;1;0;0;1;0;0]),
         var = 'xy';
      elseif all([vs1,vs2,vd1,vd2]==[2 1 2 2]) & ...
            all(var.c(:)==[0;0;1;0;0;1;0;0]),
         var = ['x';'y'];
      else err = 1;
      end;
   else err = 1;
   end;
else var = 'xy';
end;
if err, error('Invalid 2nd argument.');
end;

eval('a = pol2(a);','error(peel(lasterr));');
ad = a.d;
if isempty(ad) | any(ad<0),
   if strcmp(var,'x') | strcmp(var,'y'),
      b = a;
   elseif strcmp(var,'xy'),
      b = cell(1,2);
      b{1} = a; b{2} = a;
   else
      b = cell(2,1);
      b{1} = a; b{2} = a;
   end;
else
   as = a.s; as1 = as(1); as2 = as(2);
   ad1 = ad(1); ad2 = ad(2);
   if ~strcmp(var,'y'),
      numbx = 1./(1:ad1+1);
      numbx = kron(numbx,ones(as));
      numbx = reshape(numbx,as1,as2,ad1+1);
      numbx = repmat(numbx,[1,1,1,ad2+1]);
      bx.d = [ad1+1,ad2];
      bx.s = as;
      bx.c = zeros(as1,as2,ad1+2,ad2+1);
      bx.c(:,:,2:ad1+2,1:ad2+1) = a.c .*numbx;
      bx.v = 'xy';
      bx.u = [];
      bx = class(bx,'pol2');
      bx = pclear(bx);
      if strcmp(var,'x'),
         b = bx;
      elseif strcmp(var,'xy'),
         b = cell(1,2);
         b{1} = bx;
      else
         b = cell(2,1);
         b{1} = bx;
      end;
   end;
   if ~strcmp(var,'x'),
      numby = 1./(1:ad2+1);
      numby = kron(numby,ones(as));
      numby = reshape(numby,as1,as2,1,ad2+1);
      numby = repmat(numby,[1,1,ad1+1,1]);
      by.d = [ad1,ad2+1];
      by.s = as;
      by.c = zeros(as1,as2,ad1+1,ad2+2);
      by.c(:,:,1:ad1+1,2:ad2+2) = a.c .*numby;
      by.v = 'xy';
      by.u = [];
      by = class(by,'pol2');
      by = pclear(by);
      if strcmp(var,'y'),
         b = by;
      else
         b{2} = by;
      end;
   end;
end;

%end  .. @pol2/integral


      
      