function B = mirror(A)
%MIRROR   Mirror image of 2-D polynomial
%
% B = MIRROR(A) where A is 2-D polynomial,
% returns the mirror image of A:
%    B(x,y) = A(-x,-y)

B = A; B.u = [];

Ad = A.d;
if isempty(Ad), return;
end;

An1 = Ad(1)+1; An2 = Ad(2)+1;
if isinf(An1), An1 = 0;
end;
if isinf(An2), An2 = 0;
end;

An1h = ceil(An1/2); An2h = ceil(An2/2);
g = ones(1,1,2,2);
g(1,1,2,1) = -1; g(1,1,1,2) = -1;
gg = repmat(g,[B.s(1),B.s(2),An1h,An2h]);
gg = gg(:,:,1:An1,1:An2);

B.c = B.c .* gg;

%end .. @pol2/mirror
