function [td,P,Q] = testdp(P,Q)
%TESTDP    Test dimensions of 2-D polynomials
%             [TD,P,Q] = TESTDP(P,Q)
% The command tests whether the dimensions of 2-D polynomials P,Q are the same
% (resulting TD = 1). Admissible is also a case when one of the arguments
% is scalar. Its dimensions are changed according to the other argument,
% all entries being filled with the scalar. In other cases, TD = 0 .

td = 1;
if ~all(P.s==Q.s),
   if all(P.s==1),
      P = repmat(P,Q.s);
   elseif all(Q.s==1),
      Q = repmat(Q,P.s);
   else
      td = 0;
   end;
end;

%end .. @pol2/private/testdp
