function P2=pzer(P2);
% P2=PZER(P2) set small coefficients to zero.
%
% The tolerence-treshhold is given by 
% global zeroing tolerance
%
% Imaginary and real part of a cofficient
% are handled separately.
%
% PZER is inherent called after all algebraical
% operations.

if nargin ~= 1,
   error('One input-argument only allowed.');
end;

global PGLOBAL; 
try,
    tolerence_treshhold=PGLOBAL.ZEROING;
catch,
    painit;
end;

if tolerence_treshhold > 0, 
   if isreal(P2.c),
      P2.c(abs(P2.c)<tolerence_treshhold)=0;
   else,
      Pr=real(P2.c); Pi=imag(P2.c);
      Pr(abs(Pr)<tolerence_treshhold)=0;
      Pi(abs(Pi)<tolerence_treshhold)=0;
      P2.c=Pr+i*Pi;
   end;
end; 

P2=pclear(P2);