function B=repmat(A,M,N);
%  REPMAT Replicate  an POL2 matrix.
%    B = repmat(A,M,N) creates a large matrix B consisting of an M-by-N
%    tiling of copies of A. 

if nargin<2,
   error('Not enough input arguments.');
end;

lM = length(M);
if ~isa(M,'double') | lM<1 | lM>2 | ~isreal(M) | ...
      any(M<0) | any(floor(M)~=M),
   error('Invalid 2nd argument.');
end;
if nargin==2,
   if lM==1,
      MN = [M M];
   else
      MN = M;
   end;
else
   if ~isa(N,'double') | length(N)~=1 | ~isreal(N) | ...
         N<0 | floor(N)~=N | lM>1,
      error('Invalid 3rd argument.');
   end;
   MN = [M N];
end;

A=pol2(A);

% B.d = A.d;
if all(MN~=0), B.d = A.d;
else B.d = [];
end
B.s = A.s .* MN;
B.c = repmat(A.c,MN);
B.v = A.v;
B.u = [];

B = class(B,'pol2');

%end .. @pol2/repmat
