function Z = rot90(A,k);
%ROT90    Rotate the 2-D polynomial matrix counter-clockwise

if nargin==1, k = 1;
else
   if length(k)~=1 | ~isa(k,'double') | ~isreal(k) | floor(k)~=k,
      error('Invalid 2nd argument; must be scalar integer.');
   end;
end;
 
k = rem(k,4);
if k < 0, k = k + 4; end;

Z = A;
if k>0,
   for l = 1:k,
      Z.s = fliplr(Z.s);
      Z.c = flipdim( permute(Z.c,[2 1 3 4]), 1);
   end;
end;

%end .. @pol2/rot90
