function P = subsasgn(P,S,R)
%SUBSASGN  Subscripted assignment for 2-D polynomial

if nargin<3,
   error('Not enough input arguments.');
end;
if ~isstruct(S),
   error('Invalid 2nd argument.');
end;

S_lg = length(S); S1 = S(1);
St1 = S1.type; Ss1 = S1.subs;
Ss1_lg = length(Ss1);

switch St1,
case '.',
   flstr = lower(Ss1); flstr1 = flstr(1);
   switch flstr1,
   case 'u',
      S(1) = [];
      if isempty(S),
         P.u = R;
      else
         Pu = P.u;
         eval('Pu = subsasgn(Pu,S,R);', 'error(peel(lasterr));');
         P.u = Pu;
      end;
      
   otherwise
      error('Invalid field in subscripted assignment.');
   end;
   
case '()',
   if S_lg>1,
      error('Invalid combination in subscripted assignment.');
   end;
   Ps = P.s; Pd = P.d;
   if isempty(Pd) | any(isinf(Pd)),
      Pd = [0 0];
      Pc = zeros(Ps(1),Ps(2),1,1);
   else
      Pc = P.c;
   end;
   
   S_par.type = '()';
   S_par.subs = cell(1,4);
   S_par.subs{1} = Ss1{1};
   if Ss1_lg==2,
      S_par.subs{2} = Ss1{2};
   elseif Ss1_lg==1,
      Pc = reshape(Pc,Ps(1)*Ps(2),1,Pd(1)+1,Pd(2)+1);
      S_par.subs{2} = 1;
   else
      error('More than two subscripts.');
   end;
   S_par.subs{3} = ':';
   S_par.subs{4} = ':';
      
   if isa(R,'double') & ndims(R)<=4,
      R = pol2(R);
   elseif ~isa(R,'pol2'),
      error('Argument cannot be asigned to 2-D polynomial.');
   end;
   Rs = R.s; Rd = R.d;
   if isempty(Rd) | any(isinf(Rd)),
      Rd = [0 0];
      Rc = zeros(Rs(1),Rs(2),1,1);
   else
      Rc = R.c;
   end;
   [Pc1,Pc2,Pc3,Pc4] = size(Pc);   
   [Rc1,Rc2,Rc3,Rc4] = size(Rc);
   
   if Rc1==0 & Rc2==0,
      par1 = S_par.subs{1}; par2 = S_par.subs{2};
      if ischar(par1),
         if isnumeric(par2),
            par2 = ['[',num2str(par2),']'];
         end;
      else
         if isnumeric(par2),
            error('Invalid subscripted empty assignment.');
         end;
         par1 = ['[',num2str(par1),']'];
      end;
      retez = ['Pc(',par1,',',par2,',:,:)=[];'];
      eval(retez,'error(lasterr);');
   else
      if Pc3>Rc3,
         Rc = cat(3,Rc,zeros(Rc1,Rc2,Pc3-Rc3,Rc4));
         Rc3 = Pc3;
      end;
      if Pc4>Rc4,
         Rc = cat(4,Rc,zeros(Rc1,Rc2,Rc3,Pc4-Rc4));
         Rc4 = Pc4;
      end;
      if Rc3>Pc3,
         Pc = cat(3,Pc,zeros(Pc1,Pc2,Rc3-Pc3,Pc4));
         Pc3 = Rc3;
      end;
      if Rc4>Pc4,
         Pc = cat(4,Pc,zeros(Pc1,Pc2,Pc3,Rc4-Pc4));
         Pc4 = Rc4;
      end;
      eval('Pc = subsasgn(Pc,S_par,Rc);','error(peelf(lasterr));');
   end;

   P = pol2(Pc);
   
case '{}',
   if S_lg>1,
      error('Invalid combination in subsripted assignment.');
   end;
   Pd = P.d; Ps = P.s;
   if isempty(Pd) | any(isinf(Pd)),
      Pd = [0 0];
      Pc = zeros(Ps(1),Ps(2),1,1);
   else
      Pc = P.c;
   end;
   [Pc1,Pc2,Pc3,Pc4] = size(Pc);
   
   S_par.type = '()';
   S_par.subs = cell(1,4);
   S_par.subs{1} = ':';
   S_par.subs{2} = ':';
   if Ss1_lg==1,
      if isempty(Pd) | Pd(1)<=0,
         par3 = 0; par4 = Ss1{1};
      elseif Pd(2)<=0,
         par3 = Ss1{1}; par4 = 0;
      else
         error('Two subscripts in {} needed.');
      end;
   else  
      par3 = Ss1{1};
      par4 = Ss1{2};
   end;
   if isnumeric(par3), par3 = par3+1;
   end;
   S_par.subs{3} = par3;
   if isnumeric(par4), par4 = par4+1;
   end;
   S_par.subs{4} = par4;
   
   eval('R = double(R);','error(peel(lasterr));');
   [R1,R2,R3,R4] = size(R);
   
   if ndims(R)==2 & R1==0 & R2==0,
      if ischar(par3),
         if isnumeric(par4),
            par4 = ['[',num2str(par4),']'];
         end;
      else
         if isnumeric(par4),
            error('Invalid subscripted empty asignment.');
         end;
         par3 = ['[',num2str(par3),']'];
      end;
      retez = ['Pc(:,:,',par3,',',par4,')=[];'];
      eval(retez,'error(lasterr);');
   else
      eval('Pc = subsasgn(Pc,S_par,R);','error(peelf(lasterr));');
   end;
   
   P = pol2(Pc);
      
otherwise
   error('Invalid 2nd argument.');
end;

%end .. @pol2/subsasgn

