function C = vertcat(varargin)
%VERTCAT  Vertical conatenation of 2-D polynomials
%

% process the 1st input
Pom = [];
eval('Pom = pol2(varargin{1});','error(''Invalid argument.'');');
Pdeg = Pom.d;
Ps = Pom.s;
Pcoef = Pom.c;

% size checking
ni = length(varargin);
if ni>=2,
   for i = 2:ni,
      pom = varargin{i};
      eval('pom = pol2(pom);','error(''Invalid argument.'');');
      if pom.s(2)~=Ps(2),
         error('Matrix has not the same number of columns as the other ones.');
      end;
   end;
end;

%concatenation
if ni>=2,
   for i = 2:ni,
      pom = pol2(varargin{i});
      if isempty(Pdeg),
         Pdeg = pom.d;
      elseif ~isempty(pom.d),
         Pdeg = max(Pdeg,pom.d);
      end;   
      
      % new coefficient array
      pcs3 = size(Pcoef,3); pcs4 = size(Pcoef,4);
      [poms1,poms2] = size(pom);
      poms3 = size(pom.c,3); poms4 = size(pom.c,4);
      maxs3 = max(poms3,pcs3);
      difs3 = poms3 - pcs3; difs4 = poms4 - pcs4;
      Pcoef = cat(1,cat(4,cat(3,Pcoef,zeros(Ps(1),Ps(2),difs3,pcs4)),...
         zeros(Ps(1),Ps(2),maxs3,difs4)),...
         cat(4,cat(3,pom.c,zeros(poms1,poms2,-difs3,poms4)),...
         zeros(poms1,poms2,maxs3,-difs4)));
      
      % new size
      Ps = [Ps(1) + poms1, Ps(2)];
   end;
end;

C.d = Pdeg;
C.s = Ps;
C.c = Pcoef;
C.v = 'xy';
C.u = [];

C = class(C,'pol2');

%end .. @pol/vertcat
