function [varargout]=msl(varargin);
% Make the Same Length
% arrange the 3rd and 4th dimensions of POL2SP-coeficient-matrixes
% to the same length - resampling 
%   [oa1,oa2]=msl(ia1,ia2,..,iak,n)
% oa         - output arguments
% ia         - input arguments
% n          - number of spectrum points (used the nearest upper POWER2 number)
%            - exm: n=6 => the nearest number so spectrum points is 8
ni=nargin;
% syntax-CHECK
if ni < 1,
   error('Too few input arguments.');
end;
%-----------------------------------------
% is the last argument a POL2SP-matrix or explicite number of points?
n=[[],[]];
q=varargin{ni};
if isa(varargin{ni},'double'),
    if ~all(size(varargin{ni})==[1,2]),
        error('The vector of spectra-points has wrong size. It has to be a 1x2 integer vector.');
    end;
   n=2.^ceil(log2(floor(varargin{ni})));
   ni=ni-1;
end;
%-----------------------------------------
% minimal n of points for the correct interpretation in the spectrum
degrees=[];
for narg=1:1:ni,
   if ~isa(varargin{narg},'pol2sp'),
      error(['The ',int2str(narg),'. argument is not a POL2SP-object']);
   end;
   degrees=[degrees;varargin{narg}.d];
end;
%-----------------------------------------
%solve the of number of points
mnop=2.^ceil(log2(floor([1,1]+max(degrees,[],1)))); % the min number of demandet points
npoints=max([n;mnop],[],1);
%-----------------------------------------
% resampling to "number_of_points" length
for narg=1:1:ni,
   rate=(varargin{narg}.n)./npoints; % indicator for following operations
   %-----------------------------------------
   if all(rate==[1,1])% without modifications
      varargout{narg}=varargin{narg};
   %-----------------------------------------   
   elseif all(log2(rate)==abs(floor(log2(rate)))),% rate=2,4,8,16,... reduction of points to the half, quarter, ...
      C.d=varargin{narg}.d;
      C.n=npoints;
      C.s=varargin{narg}.s;
            sizeC=varargin{narg}.s;
      C.c=zeros(sizeC(1),sizeC(2),npoints);
            naux=varargin{narg}.n;
      C.c(:,:,1:npoints(1),1:npoints(2))=varargin{narg}.c(:,:,1:rate(1):naux(1),1:rate(2):naux(2));
      C.v=varargin{narg}.v;
      C.u=varargin{narg}.u;
      C.k=varargin{narg}.k;
      
      varargout{narg}=class(C,'pol2sp');
   %-----------------------------------------
   else % is not dividable or multiplacatible
      varargout{narg}=pol2sp(pol2(varargin{narg}),npoints);
   end;
%-----------------------------------------
end;

% end .. @pol2sp\msl.m