function f=pol2(F),
% converter POL2SP -> POL2

if (nargin~=1),
   error('Incorect number of inputs.');
elseif (nargout > 1),
   error('Incorect number of outputs');
end % if


Nsp=F.n;
degree=F.d;

if all(F.d == [-Inf,-Inf]),
   f=pol2(zeros(F.s));
   
elseif all(F.d == [0,0]), % constant matrix
   f=pol2(F.c(:,:,1,1));
   
else,
   
   f0=conj(fft((fft(conj(F.c),Nsp(1),3)),Nsp(2),4))./(prod(Nsp)); % computing 'per-partes'
   f0=f0(:,:,1:(degree(1)+1),1:(degree(2)+1));
   f=pol2(f0,'xy');
   
end;

f=pzer(f);