function B = mirror(A)
%MIRROR   Mirror image of two-sided 2-D polynomial

Ad = A.p.d;
if isempty(Ad) | any(Ad<0),
   B = A; return;
end;

Ad1 = Ad(1); Ad2 = Ad(2);
Bc = A.p.c(:,:,Ad1+1:-1:1,Ad2+1:-1:1);
BB = pol2(Bc); B = tsp2(BB);
B = shift(B,-A.o-[Ad1,Ad2]);

%end .. $tsp2/mirror
