function T = tclear(T)
%TCLEAR   Clear two-sided 2-D polynomial
%
% Remove zero leading and trailinfg coefficients
% of  T.p  and sets the offsets  T.o  correspondingly.

Tc = T.p.c;
if ~isempty(Tc),
   [sr,sc,sx,sy] = size(Tc);
   rx = zeros(1,sx);
   rx(:) = any(any(any(Tc,1),2),4);
   fx = find(rx);
   ry = zeros(1,sy);
   ry(:) = any(any(any(Tc,1),2),3);
   fy = find(ry);
   minfx = min(fx); minfy = min(fy);
   Tc = Tc(:,:,minfx:max(fx),minfy:max(fy));
   T.p = pol2(Tc);
   T.o = T.o + [minfx-1,minfy-1];
end;

%end .. %tsp2/privale/tclear
