function Ts = shift(T,n,m)
%SHIFT     Shift two-sided 2-D polynomial

na = nargin;
if na==3,
   if ~isa(n,'double') | ndims(n)>2 | ~isreal(n) | ...
         (~isempty(n) & any(any(floor(n)~=n))),
      error('Invalid 2nd argument; must be integer.');
   end;
   if ~isa(m,'double') | ndims(m)>2 | ~isreal(m) | ...
         (~isempty(m) & any(any(floor(m)~=m))),
      error('Invalid 3rd argument; must be integer.');
   end;
elseif na==2,
   if ~isa(n,'double') | ndims(n)>2 | length(n)~=2 | ...
         ~isreal(n) | any(any(floor(n)~=n)),
      error('Invalid 2nd argument or missing 3rd one.');
   end;
   m = n(2); n = n(1);
else
   error('Not enough input arguments.');
end;

eval('T = tsp2(T);', 'error(peel(lasterr));');
ns = size(n); Ts = T.s;
if all(ns==1),           % n  is scalar
   if any(Ts~=1),                  % T  is matrix
      n = ones(Ts)*n;
   end;
else                     % n  is matrix
   if all(Ts==1),                  % T  is scalar
      T = ones(ns)*T; Ts = T.s;
   else                            % T  is matrix
      if any(Ts~=ns),
         error('Matrices not of the same dimensions.');
      end;
   end;
end;

ms = size(m);
if all(ms==1),
   if any(Ts~=1),
      m = ones(Ts)*m;
   end;
else
   if all(Ts==1),
      T = ones(ms)*T; Ts = T.s;
      n = ones(ms)*n;
   else
      if any(Ts~=ms),
         error('Matrices not of the same dimensions.');
      end;
   end;
end;

Ts = T; Td = T.d;
if ~(isempty(Td) | any(Td<0)),
   nmin = min(min(n)); mmin = min(min(m));
   Ts.p = shift(Ts.p,n-nmin,m-mmin);
   Ts.o = Ts.o + [nmin mmin];
end;

%end .. @tsp2/shift

   