function Z = value(F,X,Y)
%VALUE      Value of constant
%
% For constant F (i.e. standard Matlab matrix),
% the command  Z = VALUE(F,X,Y)  returns F or
% F * ones-matrix of dimension of X or Y.
% Matrices F,X,Y must have the same dimensions
% unless some of them is scalar. Matrices X,Y
% may be omitted.
%
% This macro exists only for completeness.
% See also POL2/VALUE.

ni = nargin;
if ni<1,
   error('Not enough input arguments.');
end;
if ~isa(F,'double') | ndims(F)>2,
   error('Invalid 1st argument.');
end;

if ni==3,
   eval('Z = value(pol2(F),X,Y);','error(peel(lasterr));');
elseif ni==2,
   eval('Z = value(pol2(F),X);','error(peel(lasterr));');
else
   eval('Z = value(pol2(F));','error(peel(lasterr));');
end;

%end .. value

